<?php

	/**
	 * Dieses Modul ist für die Ausgabe der Produktbilder zuständig
	 */
	class wpsg_mod_produktbilder extends wpsg_mod_basic
	{
		
		var $lizenz = 1;
		var $id = 120;
		var $hilfeURL = 'http://wpshopgermany.de/?p=530';
		
		/**
		 * Costructor
		 */
		public function __construct()
		{
			
			parent::__construct();
			
			$this->name = __('Produktbilder', 'wpsg');
			$this->group = __('Produkte', 'wpsg');
			$this->desc = __('Ermöglicht es Bilder zu Produkten anzugeben.', 'wpsg');
						
		} // public function __construct()
		
		public function install() 
		{ 
			 
			if ($this->shop->get_option('wpsg_mod_produktbilder_width') === false || $this->shop->get_option('wpsg_mod_produktbilder_width') == '') $this->shop->update_option('wpsg_mod_produktbilder_width', '150');
			if ($this->shop->get_option('wpsg_mod_produktbilder_height') === false || $this->shop->get_option('wpsg_mod_produktbilder_height') == '') $this->shop->update_option('wpsg_mod_produktbilder_height', '150');
			
			$this->shop->checkDefault('wpsg_mod_produktbilder_mode', 's');
			$this->shop->checkDefault('wpsg_mod_produktbilder_quality', '75');
			
		} // public function install()
		
		/**
		 * 
		 * Enter description here ...
		 */
		function wpsg_enqueue_scripts()
		{
			
			if (is_admin() && preg_match('/wpsg/', wpsg_getStr($_REQUEST['page'])))
			{
			
				wp_enqueue_script('wpsg_ajaxupload', $this->shop->getRessourceURL('js/ajaxupload.js'));
				wp_enqueue_media();
				
			}
				
		} // function wpsg_enqueue_scripts()
		
		public function be_ajax() 
		{ 
		
			if ($_REQUEST['wpsg_mod_produktbilder_clearcache'] == '1')
			{

				$this->picClearCash();
				$this->shop->addBackendMessage(__('Bildercache gelöscht.', 'wpsg')); 
				
				$this->shop->redirect(WPSG_URL_WP.'wp-admin/admin.php?page=wpsg-Admin&action=module&modul=wpsg_mod_produktbilder');
				
			}
			
		} // public function be_ajax()
		
		public function settings_edit()
		{
			 			
			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_produktbilder/settings_edit.phtml');
			
		} // public function settings_edit()
		
		public function settings_save()
		{
			
			$this->shop->update_option('wpsg_mod_produktbilder_width', $_REQUEST['wpsg_mod_produktbilder_width']);
			$this->shop->update_option('wpsg_mod_produktbilder_height', $_REQUEST['wpsg_mod_produktbilder_height']);
			$this->shop->update_option('wpsg_mod_produktbilder_mode', $_REQUEST['wpsg_mod_produktbilder_mode']);
			if ($_REQUEST['wpsg_mod_produktbilder_quality'] == '') $_REQUEST['wpsg_mod_produktbilder_quality'] = 75;
				
			$this->shop->update_option('wpsg_mod_produktbilder_quality', $_REQUEST['wpsg_mod_produktbilder_quality']);
			
		} // public function settings_save()
		
		public function admin_presentation() 
		{ 

			echo wpsg_drawForm_Checkbox('wpsg_mod_produktbilder_basketimage', __('Produktbild im Warenkorb anzeigen', 'wpsg'), $this->shop->get_option('wpsg_mod_produktbilder_basketimage'));
			echo wpsg_drawForm_Checkbox('wpsg_mod_produktbilder_overviewimage', __('Produktbild in Bestellzusammenfassung anzeigen', 'wpsg'), $this->shop->get_option('wpsg_mod_produktbilder_overviewimage')); 
			
			
		} // public function admin_presentation()
		
		public function admin_presentation_submit() 
		{ 
			
			$this->shop->update_option('wpsg_mod_produktbilder_basketimage', $_REQUEST['wpsg_mod_produktbilder_basketimage']);
			$this->shop->update_option('wpsg_mod_produktbilder_overviewimage', $_REQUEST['wpsg_mod_produktbilder_overviewimage']);
			
		} // public function admin_presentation_submit()
		 
		public function picClearCash($product_id = false)
		{	
			 
			if (wpsg_isSizedInt($product_id))
			{
				
				if (file_exists($this->getPicPath('').$product_id.'/tn/')) wpsg_rrmdir($this->getPicPath('').$product_id."/tn/");
				
			}
			else
			{
			
				$handle = opendir($this->getPicPath(''));
				
				$arFiles = array();
				while (false !== ($filename = readdir($handle))) 
		   		{
		   				
		   			if (is_dir($this->getPicPath('').$filename) && $filename != "." && $filename != ".." && $filename != '')
		   			{
		   				
		   				if (file_exists($this->getPicPath('').$filename.'/tn/')) wpsg_rrmdir($this->getPicPath('').$filename."/tn/");
		   				
		   			}
		   			
		   		}
		   		
			}

		} // public function picClearCash()

		public function produkt_ajax() 
		{
			global $wpdb;
			
			if (wpsg_isSizedString($_REQUEST['cmd'], 'clearProductCache'))
			{
				
				$this->picClearCash($_REQUEST['edit_id']);
				
				die(__('Bildercache erfolgreich gelöscht.', 'wpsg'));
				
			}
			else if ($_REQUEST['cmd'] == 'upload')
			{
 
				foreach ($_FILES['userfile']['tmp_name'] as $k => $file_tmp_name)
				{
				
					if (file_exists($file_tmp_name))
					{
							
						$uploaddir = $this->getPicPath($_REQUEST['edit_id']);
							
						if (!file_exists($uploaddir)) mkdir($uploaddir, 0777, true);
						if (!file_exists($uploaddir.'tn/')) mkdir($uploaddir.'tn/', 0777, true);
							
						$uploadfile = $uploaddir.basename($_FILES['userfile']['name'][$k]);
							
						move_uploaded_file($file_tmp_name, $uploadfile);
							
						$uri = $this->makeTn($_REQUEST['edit_id'], $_FILES['userfile']['name'][$k], get_option("wpsg_mod_produktbilder_width"), get_option("wpsg_mod_produktbilder_height"), get_option("wpsg_mod_produktbilder_mode"));
							
						if ($this->shop->hasMod('wpsg_mod_produktartikel')) $this->shop->callMod('wpsg_mod_produktartikel', 'updatePostThumbnail', array($_REQUEST['edit_id']));
													
					}
					else
					{
							
						die(__('Fehler beim Upload! Datei existiert nicht.', 'wpsg'));
							
					}
										
				}
				
				die("1");
				
			}
			else if ($_REQUEST['cmd'] == 'remove')
			{
								
				unlink($this->getPicPath($_REQUEST['edit_id']).'/'.$_REQUEST['file']);
				
				$this->shop->view['data']['id'] = $_REQUEST['edit_id'];			
				
				if ($this->shop->hasMod('wpsg_mod_produktartikel')) $this->shop->callMod('wpsg_mod_produktartikel', 'updatePostThumbnail', array($_REQUEST['edit_id']));
				
				die($this->getProduktBilderListe($_REQUEST['edit_id']));
				
			}
			else if ($_REQUEST['cmd'] == 'produktbilder_liste')
			{
				
				$this->shop->view['data']['id'] = $_REQUEST['edit_id'];				
				die($this->getProduktBilderListe($_REQUEST['edit_id']));
				
			}
			else if ($_REQUEST['cmd'] == 'upload_mt')
			{
				
				// Mediathek				
				$fname = $_FILES['userfile']['name'][0];

				$filetype = wp_check_filetype( basename( $fname ), null );
				$wp_upload_dir = wp_upload_dir();
				$attachment = array(
					'guid' => wpsg_q($wp_upload_dir['url'] . '/' . basename($fname)),
					'post_mime_type' => wpsg_q($filetype['type']),
					'post_title' => wpsg_q(preg_replace('/\.[^.]+$/', '', basename($fname))),
					'post_excerpt' => wpsg_q($fname),
					'post_parent' => '0',
					'wpsg_produkt_id' => '6',
					'post_status' => 'inherit'
				);
				
				$_FILES = $this->diverse_array($_FILES['userfile']);
				$attachment_id = media_handle_upload( '0', 0, $attachment );	//OK
				
				// Feld wpsg_produkt_id setzen mit $_REQUEST['edit_id']
				//$this->db->UpdateQuery($wpdb->prefix."posts", array(
				//	"wpsg_produkt_id" => $_REQUEST['edit_id']), "`ID` = '".wpsg_q($attachment_id)."'");
				add_post_meta( $attachment_id, 'wpsg_produkt_id', $_REQUEST['edit_id'] );
				
				
				// Tests
				$p1 = wp_get_attachment_url($attachment_id);	// http://shop4.home/wp-content/uploads/2017/03/hdrechteckig.png
				$p2 = get_attached_file( $attachment_id ); 		// C:\xampp\htdocs\wp2/wp-content/uploads/2017/03/hdrechteckig.png
				$p3 = get_attachment_link( $attachment_id );	// http://shop4.home/hdrechteckig/
				$p4 = get_the_title( $attachment_id );			// hdrechteckig
				$p5 = get_post_type($attachment_id);			// attachment
				$p6 = get_post($attachment_id);					// WP_Post
				$p7 = wp_get_attachment_image_src($attachment_id, 'thumbnail');	// Array mit Full-URL, Width, Height
				
				add_image_size('s_40_40', 40, 40);
				$ht = wp_get_attachment_image( $attachment_id, Array(40, 40));
				$p8 = wp_get_attachment_image_src($attachment_id, Array(40, 40));
				$p80 = $p8[0];
				
				//$rw = add_post_meta( $attachment_id, 'wpsg_produkt_id', '6' );
				//$rw = add_post_meta( $attachment_id, 'wpsg_produkt_id', '5' );
				//$rw = add_post_meta( $attachment_id, 'wpsg_produkt_id', '4' );
				//$rw = get_post_meta( $attachment_id, 'wpsg_produkt_id' );
				
				unset($_FILES[0]);
				$i = 1;
				foreach ($_FILES as $key => $val) {
					// File hochladen und Feld wpsg_produkt_id setzen
					$fname = $val['name'];
					$filetype = wp_check_filetype( basename( $fname ), null );
					$attachment['post_mime_type'] = $filetype['type'];
					$attachment['guid'] = $wp_upload_dir['url'] . '/' . basename( $fname );
					$attachment['post_title'] = preg_replace( '/\.[^.]+$/', '', basename( $fname ) );
					$attachment['post_excerpt'] = wpsg_q($fname);
					$attachment_id = media_handle_upload( $i, 92, $attachment );
					//$this->db->UpdateQuery($wpdb->prefix."posts", array(
					//		"wpsg_produkt_id" => $_REQUEST['edit_id']), "`ID` = '".wpsg_q($attachment_id)."'");
					add_post_meta( $attachment_id, 'wpsg_produkt_id', $_REQUEST['edit_id'] );
					$i++;
				}
				
				die("1");
				
			}
			else if ($_REQUEST['cmd'] == 'removemt')
			{
			
				//unlink($this->getPicPath($_REQUEST['edit_id']).'/'.$_REQUEST['file']);
				if ($_REQUEST['delmt'] === 'true') {	// Auch in der Mediathek löschen
					wp_delete_post( $_REQUEST['pid'], true );
				}
				
				// Zuordnung löschen
				delete_post_meta( $_REQUEST['pid'], 'wpsg_produkt_id', $_REQUEST['edit_id'] );
				
				$this->shop->view['data']['id'] = $_REQUEST['edit_id'];
			
				if ($this->shop->hasMod('wpsg_mod_produktartikel')) $this->shop->callMod('wpsg_mod_produktartikel', 'updatePostThumbnail', array($_REQUEST['edit_id']));
			
				die($this->getProduktBilderListe_MT($_REQUEST['edit_id']));
			
			}
			else if ($_REQUEST['cmd'] == 'uploadmt')
			{
				//die('uploadmt');
				
				add_post_meta( $_REQUEST['post']['id'], 'wpsg_produkt_id', $_REQUEST['edit_id'] );
				
				$this->shop->view['data']['id'] = $_REQUEST['edit_id'];
				die($this->getProduktBilderListe_MT($_REQUEST['edit_id']));
				
			}
			else if ($_REQUEST['cmd'] == 'produktbilder_liste_MT')
			{
			
				$this->shop->view['data']['id'] = $_REQUEST['edit_id'];
				//$content = $this->getProduktBilderListe($_REQUEST['edit_id']);
				die($this->getProduktBilderListe_MT($_REQUEST['edit_id']));
				
			}
			else if ($_REQUEST['cmd'] == 'wpsg_setImageOrder')
			{
				$reo = $_REQUEST['wpsg_reorder'];
				$pid = $_REQUEST['edit_id'];
				
				$file = '';
				$line = '';
				$b = headers_sent($file, $line);
				$a = headers_list();
				
				$sreo = '';
				foreach ($reo as $v) {
					$st = explode('_', $v);
					$sreo .= $st[1].',';
				}
				
				$sreo = substr($sreo, 0, strlen($sreo) - 1);
				
				$this->db->UpdateQuery(WPSG_TBL_PRODUCTS, array("postids" => wpsg_q($sreo)), "`id` = '".wpsg_q($pid)."'");
				
				flush();
				die('1');
				
			}
			
		} // public function produkt_ajax()
		
		public function diverse_array($vector) 
		{
			
			$result = array();
			
			foreach($vector as $key1 => $value1)
			{
				
				foreach($value1 as $key2 => $value2)
				{
					
					$result[$key2][$key1] = $value2;
					
				}
				
			}
			
			return $result;
			
		}
		
		
		public function produkt_save(&$produkt_id) 
		{ 
		
			if (wpsg_isSizedArray($_FILES['wpsg_mod_produktbilder_file']))
			{
				
				foreach ($_FILES['wpsg_mod_produktbilder_file']['tmp_name'] as $k => $file_tmp_name)
				{
			
					if (file_exists($file_tmp_name))
					{
					
						$uploaddir = $this->getPicPath($produkt_id);
					
						if (!file_exists($uploaddir)) mkdir($uploaddir, 0777, true);
						if (!file_exists($uploaddir.'tn/')) mkdir($uploaddir.'tn/', 0777, true);
					
						$uploadfile = $uploaddir.basename($_FILES['wpsg_mod_produktbilder_file']['name'][$k]);
					
						move_uploaded_file($file_tmp_name, $uploadfile);
					
						$uri = $this->makeTn($produkt_id, $_FILES['wpsg_mod_produktbilder_file']['name'][$k], get_option("wpsg_mod_produktbilder_width"), get_option("wpsg_mod_produktbilder_height"), get_option("wpsg_mod_produktbilder_mode"));
					
					}
					
				}
				
			}
			
		} // public function produkt_save(&$produkt_id)
		
		public function produkt_del($product_id)
		{
			
			$path_bilder = $this->getPicPath($product_id);
			wpsg_rrmdir($path_bilder);
			
		} // public function produkt_del(&$product_id)
		 
		public function product_addedit_content(&$product_content, &$product_data)
		{
			
			// Wenn eine Übersetzung bearbeitet wird, dann nichts machen
			if (isset($_REQUEST['wpsg_lang'])) return;
			 										
			if (wpsg_isSizedInt($product_data['id']))
			{
			
				$this->shop->view['modul'] = &$this;
				$this->shop->view['ProduktBilderPath'] = $this->getPicPath($product_data['id']);
				$this->shop->view['ProduktBilderURL'] = $this->getPicPath($product_data['id'], true);
				$this->shop->view['ProduktList'] = $this->getProduktBilderListe($product_data['id']);
			
				$this->shop->view['ProduktList_MT'] = $this->getProduktBilderListe_MT($product_data['id']);
				
			}
			
			$product_content['wpsg_mod_productbilder'] = array(
				'title' => __('Produktbilder', 'wpsg'),
				'content' => $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_produktbilder/produkt_addedit_content.phtml', false)
			);
			
		} // public function product_addedit_content(&$product_content, &$produkt_data)
		
		public function produkt_edit_content(&$produkt_data) 
		{ 
			
			if (isset($_REQUEST['wpsg_lang'])) return;
			
			$this->shop->view['data'] = $produkt_data;
			
			if ($produkt_data['id'] > 0)
			{

				$this->shop->view['modul'] = &$this;
				$this->shop->view['ProduktBilderPath'] = $this->getPicPath($produkt_data['id']);
				$this->shop->view['ProduktBilderURL'] = $this->getPicPath($produkt_data['id'], true);
				$this->shop->view['ProduktList'] = $this->getProduktBilderListe($produkt_data['id']);
				
			}
			
			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_produktbilder/produkt_edit_content.phtml');	
			
		} // public function produkt_edit_content(&$produkt_data)
		
		public function produkt_createTranslation(&$produkt_id, &$trans_id)
		{
			
		 	$path_src = $this->getPicPath($produkt_id);
		 	$path_trg = $this->getPicPath($trans_id);
		 	
		 	wpsg_copy($path_src, $path_trg);
			
		} // public function produkt_createTranslation(&$produkt_id, &$trans_id)
		
		public function produkt_copy(&$produkt_id, &$copy_id) { 
			
			// Wie bei der Erstellung einer neuen Übersetzung ...
			$this->produkt_createTranslation($produkt_id, $copy_id);
			
		} // public function produkt_copy(&$produkt_id, &$copy_id)
		
		public function checkGeneralBackendError()
		{
			
						
		} // public function checkGeneralBackendError()
		
		/* Modulfunktionen */

		/**
		 * Mediatheksfunktion
		 * Fügt ein neues Bild zu einem Produkt hinzu
		 * 
		 * @param String $file Absoluter Pfad zu dem Bild
		 * @param $product_id ID des Produktes zu dem das Bild zugeordnet werden soll
		 */
		public function addImageToProduct($file, $product_id)
		{
			
			// Siehe
			// https://codex.wordpress.org/Function_Reference/wp_insert_attachment
			
			$wp_upload_dir = wp_upload_dir();
			
			$mt_filetype = wp_check_filetype(basename($file), null);
			$mt_filename = $wp_upload_dir['path'].'/'.basename($file);
			
			copy($file, $mt_filename);
			
			$attachment = array(
				'guid' => wpsg_q($wp_upload_dir['url'].'/'.basename($file)),
				'post_mime_type' => wpsg_q($mt_filetype['type']),
				'post_title' => wpsg_q(preg_replace('/\.[^.]+$/', '', basename($file))),
				'post_excerpt' => wpsg_q(basename($file)),
				'post_status' => 'inherit'
			);
			
			$attachment_id = wp_insert_attachment($attachment, $mt_filename, '0');
			
			require_once(ABSPATH.'wp-admin/includes/image.php');
			
			$attach_data = wp_generate_attachment_metadata($attachment_id, $mt_filename);
			wp_update_attachment_metadata($attachment_id, $attach_data);
			
			add_post_meta($attachment_id, 'wpsg_produkt_id', $product_id);
						
		} // public function addImageToProduct($file, $product_id)
		
		/**
		 * Wird vom Template produkt_edit_content.phtml aufgerufen und per Ajax aktualisiert.
		 * Zeichnet die Liste mit den Produktbildern
		 */
		public function getProduktBilderListe($produkt_id)
		{
			
			$this->shop->view['modul'] = &$this;
			$this->shop->view['ProduktBilderPath'] = $this->getPicPath($produkt_id);
			$this->shop->view['ProduktBilderURL'] = $this->getPicPath($produkt_id, true);
			$this->shop->view['ProduktBilder'] = $this->getProduktBilder($produkt_id);
			
			return $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_produktbilder/produkt_edit_list.phtml', false);
			
		} // public function getProduktBilderListe($produkt_id)
		
		/**
		 * Wird vom Template produkt_edit_content.phtml aufgerufen und per Ajax aktualisiert.
		 * Zeichnet die Liste mit den Produktbildern
		 */
		public function getProduktBilderListe_MT($produkt_id, $size = 'thumbnail')
		{
			global $wpdb;
			
			$data = $this->db->fetchAssoc("SELECT * FROM `".$wpdb->prefix."postmeta` WHERE `meta_key`='".wpsg_q('wpsg_produkt_id')."' AND `meta_value`='".wpsg_q($produkt_id)."' ORDER BY `post_id`");
			//$data = $this->db->fetchAssoc("SELECT * FROM `".$wpdb->prefix."posts` WHERE `wpsg_produkt_id` = '".wpsg_q($produkt_id)."' ");
			$postids = $this->db->fetchOne("SELECT `postids` FROM `".WPSG_TBL_PRODUCTS."` WHERE `id`=".wpsg_q($produkt_id));
			$arPostids = explode(',', $postids);
			
			$wp_upload_dir = wp_upload_dir();
			$url = $wp_upload_dir['url'];
			$i = 0;
			
			if (wpsg_isSizedString($postids)) {
				foreach ($arPostids as $postid) {
					
					for ($i = 0; $i < count($data); $i++) {
						if ($data[$i]['post_id'] == $postid) {
							$p = wp_get_attachment_image_src($data[$i]['post_id'], $size);	// Array mit Full-Path, Width, Height
							$guid = $p[0];
							$arrf = pathinfo($guid);
							$this->shop->view['ProduktBilder_MT'][$i]['pid'] = $data[$i]['post_id'];
							$this->shop->view['ProduktBilder_MT'][$i]['fname'] = $arrf['basename'];
							$this->shop->view['ProduktBilder_MT'][$i]['guid'] = $guid;
							
						}
					}
				}
				
			} else {
				foreach ($data as $key => $val) {
					/*
					$p1 = wp_get_attachment_url($val['ID']);
					$arrf = pathinfo($p1);
					$this->shop->view['ProduktBilder_MT'][$i]['fname'] = $arrf['basename'];
					$guid = $arrf['dirname'].'/'.$arrf['filename'].'-150x150.'.$arrf['extension'];
					*/
					$p = wp_get_attachment_image_src($val['post_id'], $size);	// Array mit Full-Path, Width, Height
					$guid = $p[0];
					$arrf = pathinfo($guid);
					$this->shop->view['ProduktBilder_MT'][$i]['pid'] = $val['post_id'];
					$this->shop->view['ProduktBilder_MT'][$i]['fname'] = $arrf['basename'];
					$this->shop->view['ProduktBilder_MT'][$i]['guid'] = $guid;
					$i++;
				}
			}
			return $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_produktbilder/produkt_edit_list_MT.phtml', false);
				
		} // public function getProduktBilderListe_MT($produkt_id)
		
		/**
		 * Gibt die verfügbaren Möglichkeiten für den Bildzuschnitt zurück
		 */
		public function getImageModes()
		{
		
			return array(		
				'n' => __('Unbearbeitet', 'wpsg'),
				's' => __('Einpassen', 'wpsg'),
				'sz' => __('Einpassen mit Freifläche', 'wpsg'),
				'z' => __('Strecken', 'wpsg'),
				'sw' => __('Skallieren auf Breite', 'wpsg'),
				'sh' => __('Skallieren auf Höhe', 'wpsg'),
				'c' => __('Zuschneiden', 'wpsg'),
				'cz' => __('Zentrieren und Abschneiden', 'wpsg')
			);
			
		} // public function getImageModes()		
		
		/**
		 * Gibt false oder die URL zu einem Bild des Produktes zurück
		 */
		public function getProductImage($product_key, $setW, $setH, $mode)
		{
			
			$product_id = $this->shop->getProduktID($product_key);
			
			$arBilder = $this->getProduktBilder($product_id);
			
			if (!wpsg_isSizedArray($arBilder))
			{
				
				$file = $this->shop->getRessourcePath('mods/mod_produktbilder/dummy.jpg');
				
				if (!file_exists($file)) return false;
				else return $this->makeTn(0, $file, $setW, $setH, $mode); 
				
			}
			
			$img_url = $this->makeTn($product_id, $arBilder[0], $setW, $setH, $mode);
			
			return $img_url;
			
		} // public function getProductImage($product_key)

		/**
		 * Gibt false oder die URL zu einem Bild des Produktes zurück
		 */
		public function getProductImage_MT($product_key, $size = 'thumbnail')
		{
			
			global $wpdb;
			
			$product_id = $this->shop->getProduktID($product_key);
			
			$data = $this->db->fetchAssoc("SELECT * FROM `".$wpdb->prefix."postmeta` WHERE `meta_key` = '".wpsg_q('wpsg_produkt_id')."' AND `meta_value` = '".wpsg_q($product_id)."' ");
				
			if (!wpsg_isSizedArray($data)) return false;

			$p = wp_get_attachment_image_src($data[0]['post_id'], $size);	// Array mit Full-Path, Width, Height
					
			$img_url = $p[0];
				
			return $img_url;
				
		} // public function getProductImage_MT($product_key)
		
		/**
		 * Gibt ein Array mit den Produktbildern zurück
		 */
		public function getProduktBilder($produkt_id)
		{
			
			$arFiles = array();

			// Bilder aus dem Dateisystem raussuchen
			$path = $this->getPicPath($this->shop->getProduktId($produkt_id));
						 
			$handle = opendir($path);
			
			while ($filename = readdir($handle))
			{
				
				if (is_file($path.'/'.$filename) && $filename != '.' && $filename != '..' && $filename != '')
				{
					
					$arFiles[] = $filename;
					
				}
				
			}
			
			wpsg_asort($arFiles);
			
			$arReturn = array();
			foreach ($arFiles as $k => $v) $arReturn[] = $v;
						
			return $arReturn;
			
		} // public function getProduktBilder($produkt_id)
		
		/**
		 * Gibt ein Array mit den Produktbildern zurück
		 * $size = 'full' sollte Originalgröße zurückgeben
		 */
		public function getProduktBilder_MT($produkt_id, $size = 'thumbnail')
		{
			
			global $wpdb;
				
			$arFiles = array();		
			
			$data = $this->db->fetchAssoc("SELECT * FROM `".$wpdb->prefix."postmeta` WHERE `meta_key` = 'wpsg_produkt_id' AND `meta_value` = '".wpsg_q($produkt_id)."' ");
			$postids = $this->db->fetchOne("SELECT `postids` FROM `".WPSG_TBL_PRODUCTS."` WHERE `id`=".wpsg_q($produkt_id));
			$arPostids = explode(',', $postids);
			
			$ud = wp_upload_dir(); 
			
			$i = 0;
			
			if (wpsg_isSizedString($postids)) {
				foreach ($arPostids as $postid) {
					
					for ($i = 0; $i < count($data); $i++) {
						if ($data[$i]['post_id'] == $postid) {
							$p = wp_get_attachment_image_src($data[$i]['post_id'], $size);	// Array mit Full-Path, Width, Height
							$guid = $p[0];
							$arrf = pathinfo($guid);

							$arFiles[$i]['guid'] = $guid;
							$arFiles[$i]['post_id'] = $data[$i]['post_id'];
							$arFiles[$i]['basename'] = $arrf['basename'];
							$arFiles[$i]['url'] = $guid;
							$arFiles[$i]['path'] = str_replace($ud['baseurl'], $ud['basedir'], $guid);
							
						}
					}
				}
				
			} else {
				
				foreach ($data as $key => $val) 
				{
					
					$p = wp_get_attachment_image_src($val['post_id'], $size);	// Array mit Full-Path, Width, Height
					 
					$guid = $p[0];
					$arrf = pathinfo($guid);
					
					//$this->shop->view['ProduktBilder_MT'][$i]['pid'] = $val['post_id'];
					//$this->shop->view['ProduktBilder_MT'][$i]['fname'] = $arrf['basename'];
					//$this->shop->view['ProduktBilder_MT'][$i]['guid'] = $guid;
					
					$arFiles[$i]['guid'] = $guid;
					$arFiles[$i]['post_id'] = $val['post_id'];
					$arFiles[$i]['basename'] = $arrf['basename'];
					$arFiles[$i]['url'] = $guid;
					$arFiles[$i]['path'] = str_replace($ud['baseurl'], $ud['basedir'], $guid);				
					
					$i++;
					
				}
			}
			/*
			wpsg_asort($arFiles);
				
			$arReturn = array();
			foreach ($arFiles as $k => $v) $arReturn[] = $v;
		
			return $arReturn;
			*/
			
			return $arFiles;
			
		} // public function getProduktBilder_MT($produkt_id)
		
		/*
 		 * Gibt den Absoluten Pfad zurück wo die Bilder gespeichert sind
 		 * Ist der Parameter $url auf true so wird der relative Pfad für die Ausgabe in URLs zurückgegeben
 		 */
 		public function getPicPath($produkt_id, $url = false)
 		{
 		 	 			
 			if ($url) $path = WPSG_URL_UPLOADS.'wpsg_produktbilder/'.$produkt_id.'/';
			else 
			{
				
				$path = WPSG_PATH_UPLOADS.'wpsg_produktbilder/'.$produkt_id.'/'; 
				
				if (!file_exists($path)) mkdir($path, 0777, true);
				 
			}
			 			
			if ($url === true) return $path;
			else return wpsg_format_path($path);
			 
 		} // private function getPicPath($produkt_id, $url = false)

 		/**
 		 * @param int $p_id Id des Produktes
 		 * @param String $file Dateiname des Bildes (Ohne Pfad)
 		 * @param int $setW Angestrebte Breite des Bildes
 		 * @param int $setH Angestrebte Höhe des Bildes
 		 * @param String $mode Modus 
 		 * 
 		 * Funktion kann jetzt auch mit Bildern umgehen, die nicht einem Produkt zugeordnet sind (z.B. dem Dummy Bild)
 		 * Einfach als p_id 0 übergeben und in $file den kompletten Pfad
  		 */
 		public function makeTn($p_id, $file, $setW, $setH, $mode)
		{
			
			if ($p_id !== 0) $p_id = $this->shop->getProduktId($p_id);

			$uploaddir = $this->getPicPath($p_id);
			$uploaddir_tn = $this->getPicPath($p_id)."tn/";
			$url_bilder = $this->getPicPath($p_id, true);
			
			if ($p_id !== 0 && !file_exists($uploaddir)) mkdir($uploaddir, 0777, true);
			if (!file_exists($uploaddir_tn)) mkdir($uploaddir_tn, 0777, true);
			
			// Default Werte
			if ($setW <= 0) $setW = 100;
			if ($setH <= 0) $setH = 100;
			if ($mode == "" || !isset($mode)) $mode = 's';
			
			if ($p_id !== 0) $src_file = $uploaddir.$file;
			else {
				
				$src_file = $file;
				$file = basename($src_file);
				
			}
			
			$trg_file = $uploaddir_tn.$mode.'-'.$setW.'-'.$setH.'-'.$file;
			
			if (!file_exists($src_file) || !is_file($src_file)) return;
			
			// Quelldatei existiert nicht
			if (!file_exists($src_file)) return "FILE NOT FOUND: ".$uploaddir.$file;
			
			if (file_exists($trg_file)) return $this->shop->url(str_replace(' ', '%20', $url_bilder."tn/".$mode.'-'.$setW.'-'.$setH.'-'.$file));
			
			$b = copy($src_file, $trg_file);
 
			$ImInf = GetImageSize($trg_file);
			$W = $ImInf[0];
			$H = $ImInf[1];
			
			switch (strtolower(preg_replace("/.*\./", "", $trg_file)))
			{
				case 'gif':
					$srcImage = imagecreatefromgif($trg_file);
					break;
				case 'png':				
					$srcImage = imagecreatefrompng($trg_file);
					break;
				case 'jpg':
					$srcImage = imagecreatefromjpeg($trg_file);
					break;
				case 'bmp':
					$srcImage = imagecreatefromwbmp($trg_file);
					break;
				default:
					return __("Unbekanntes Dateiformat", "wpsg");
			}
												
			switch (strtolower($mode))
			{
				
				case 'c':	// CROP
					
					$dstImage = ImageCreateTrueColor($setW, $setH);
					 					
					imagealphablending($dstImage, false);
					$color = imagecolortransparent($dstImage, imagecolorallocatealpha($dstImage, 0, 0, 0, 127));
					imagefill($dstImage, 0, 0, $color);
					imagesavealpha($dstImage, true);
					 					
					// Längste Seite finden
					if ($W > $H)
					{						
						$new_width = $W / ($H / $setH);
						imagecopyresampled($dstImage, $srcImage, 0 - ($new_width / 2) + ($setW / 2), 0, 0, 0, $new_width, $setH, $W, $H);
					}
					else
					{
						$new_height = $H / ($W / $setW);
						imagecopyresampled($dstImage, $srcImage, 0, 0 - ($new_height / 2) + ($setH / 2), 0, 0, $setW, $new_height, $W, $H);						
					}
					 
					break;	

				case 'cz': // CROP CENTER
				
					$dstImage = ImageCreateTrueColor($setW, $setH);
					
					imagealphablending($dstImage, false);
					$color = imagecolortransparent($dstImage, imagecolorallocatealpha($dstImage, 0, 0, 0, 127));
					imagefill($dstImage, 0, 0, $color);
					imagesavealpha($dstImage, true);
					
					$new_width = $H * $setW / $setH;
					$new_height = $W * $setH / $setW;
					
					if ($new_width > $W)
					{
						
						$y = (($H - $new_height) / 2);
						
						imagecopyresampled($dstImage, $srcImage, 0, 0, 0, $y, $setW, $setH, $W, $new_height);
						
					}
					else
					{
						
						$x = (($W - $new_width) / 2);
						
						imagecopyresampled($dstImage, $srcImage, 0, 0, $x, 0, $setW, $setH, $new_width, $H);
						
					}
					
					break;
						
				case 'z':   // STRETCH
					 
					$dstImage = ImageCreateTrueColor($setW, $setH);
					
					imagealphablending($dstImage, false);
					$color = imagecolortransparent($dstImage, imagecolorallocatealpha($dstImage, 0, 0, 0, 127));
					imagefill($dstImage, 0, 0, $color);
					imagesavealpha($dstImage, true);
					
					imagecopyresampled($dstImage, $srcImage, 0, 0, 0, 0, $setW, $setH, $W, $H); 
					break;
					
				case 'n': 	// NIX 
					
					return $url_bilder.$file;
					
					break;
					
				case 'sz':  // SCALE und Freifläche
					
					$dstImage = ImageCreateTrueColor($setW, $setH);
					list($width, $height) = $this->getNewSize($W, $H, $setW, $setH);					
					 
					imagealphablending($dstImage, false);					
					$color = imagecolortransparent($dstImage, imagecolorallocatealpha($dstImage, 255, 255, 255, 127));
					imagefill($dstImage, 0, 0, $color);
					imagesavealpha($dstImage, true);
					
					$dst_x = 0; if ($width < $setW) $dst_x = ($setW - $width) / 2;
					$dst_y = 0; if ($height < $setH) $dst_y = ($setH - $height) / 2;
					
					imagecopyresampled($dstImage, $srcImage, $dst_x, $dst_y, 0, 0, $width, $height, $W, $H);														
									
					break; 	

				case 'sw': // SCALE WIDTH
					
					$height = $H / ($W / $setW);
					
					$dstImage = ImageCreateTrueColor($setW, $height);
					
					imagealphablending($dstImage, false);
					$color = imagecolortransparent($dstImage, imagecolorallocatealpha($dstImage, 255, 255, 255, 127));
					imagefill($dstImage, 0, 0, $color);
					imagesavealpha($dstImage, true);
					
					imagecopyresampled($dstImage, $srcImage, 0, 0, 0, 0, $setW, $height, $W, $H);
						
					break;
					
				case 'sh': // SCALE HEIGHT
					
					$width = $W / ($H / $setH);
					
					$dstImage = ImageCreateTrueColor($width, $setH);
						
					imagealphablending($dstImage, false);
					$color = imagecolortransparent($dstImage, imagecolorallocatealpha($dstImage, 255, 255, 255, 127));
					imagefill($dstImage, 0, 0, $color);
					imagesavealpha($dstImage, true);
						
					imagecopyresampled($dstImage, $srcImage, 0, 0, 0, 0, $width, $setH, $W, $H);
										
					break;
										
				case 's':	// SCALE INTO
				default:
					
					list($width, $height) = $this->getNewSize($W, $H, $setW, $setH);					
					$dstImage = ImageCreateTrueColor($width, $height);
					
					imagealphablending($dstImage, false);
					$color = imagecolortransparent($dstImage, imagecolorallocatealpha($dstImage, 0, 0, 0, 127));
					imagefill($dstImage, 0, 0, $color);
					imagesavealpha($dstImage, true);
					
					imagecopyresampled($dstImage, $srcImage, 0, 0, 0, 0, $width, $height, $W, $H);														
					break;
					
			}		
			
			switch (strtolower(preg_replace("/.*\./", "", $trg_file)))
			{
				
				case 'gif':
					ImageGIF($dstImage, $trg_file);
				case 'png':

					$quality = 9 - wpsg_round($this->shop->get_option('wpsg_mod_produktbilder_quality') / 10, 0);
					if ($quality < 9) $quality = 0;
					
					$b = ImagePNG($dstImage, $trg_file, $quality);
					
					break;
				case 'jpg':
				case 'bmp':
				default:
					ImageJPEG($dstImage, $trg_file, $this->shop->get_option('wpsg_mod_produktbilder_quality'));
					break;	
								
			}		
			 
			imageDestroy($dstImage);
			imageDestroy($srcImage);	

			return $this->shop->url(str_replace(' ', '%20', $url_bilder."tn/".$mode.'-'.$setW.'-'.$setH.'-'.$file));
			
		} // private function makeTn($mode, $set_width, $set_height)
		
		/**
		 * Bestimmt die Größe im Seitenverhältnis für skalierte Bilder
		 */
		private function getNewSize($w, $h, $maxW, $maxH)
		{
		    
		    if ($w > $h)
		    {
		    	
				// Breite skalieren und schauen ob Höhe reinpasst   		
		    	// Bild ist breiter als hoch -> versuchen nach Breite zu skalieren
		    	$newWidth = $maxW;
		    	$newHeight = ($maxW / $w) * $h;
		    	
		    	if ($newHeight > $maxH)
		    	{
		    		
		    		// Bild ist nach Skalierung auf Breite zu hoch ! 
		    		// jetzt noch auf Höhe skalieren
		    		$newWidth = ($maxH / $newHeight) * $maxW;
		    		$newHeight = $maxH;  
		    		  			    			
		    	}
		    	
		    }
		    else 
		    {
		    	
		    	// Nach Höhe skalieren
		    	$newHeight = $maxH;
		    	$newWidth = ($maxH / $h) * $w;
		    	
		    	if ($newWidth > $maxW)
		    	{
		    		
		    		// Bild ist nach Skalierung auf Höhe zu schmal !
		    		// jetzt Breite anpassen
		    		$newHeight = ($maxW / $newWidth) * $maxH;
		    		$newWidth = $maxW;
		    		
		    	}
		    	
		    }
		    
		    return array($newWidth, $newHeight);
		    
		} // function getNewSize($w, $h, $maxW, $maxH)
		
	} // class wpsg_mod_produktbilder extends wpsg_mod_basic

?>